From b0b047ba5d2a1c2f48d1430d7dfb57c7e18a3666 Mon Sep 17 00:00:00 2001
From: Gabor Pali <pali.gabor@gmail.com>
Date: Fri, 10 Aug 2012 00:45:42 +0200
Subject: [PATCH] Fix build with FreeBSD versions earlier than 9.0 as
 pthread_getthreadid_np() is not available there.

---
 rts/posix/OSThreads.c | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

diff --git a/rts/posix/OSThreads.c b/rts/posix/OSThreads.c
index 7fa2f4d..2fa5670 100644
--- a/rts/posix/OSThreads.c
+++ b/rts/posix/OSThreads.c
@@ -31,6 +31,9 @@
 
 #if defined(HAVE_PTHREAD_H)
 #include <pthread.h>
+#if defined(freebsd_HOST_OS)
+#include <pthread_np.h>
+#endif
 #endif
 
 #if defined(THREADED_RTS)
@@ -330,7 +333,8 @@ KernelThreadId kernelThreadId (void)
     pid_t tid = syscall(SYS_gettid); // no really, see man gettid
     return (KernelThreadId) tid;
 
-#elif defined(freebsd_HOST_OS)
+/* FreeBSD 9.0+ */
+#elif defined(freebsd_HOST_OS) && (__FreeBSD_version >= 900031)
     return pthread_getthreadid_np();
 
 #elif defined(darwin_HOST_OS)
-- 
1.7.11.3

